Index: trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/hydrol.F90	(revision 1308)
@@ -39,6 +39,6 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F	(revision 1308)
@@ -40,5 +40,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 #include "comconst.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 1308)
@@ -10,4 +10,5 @@
       use comsoil_h, only: ini_comsoil_h
       use control_mod, only: ecritphy
+      use planete_mod, only: nres
       use planetwide_mod, only: planetwide_sumval
 
@@ -51,7 +52,7 @@
       USE ioipsl_getincom 
       IMPLICIT NONE
-#include "dimensions.h"
-#include "dimphys.h"
-#include "planete.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
+!#include "planete.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -88,14 +89,4 @@
       avocado = 6.02214179e23   ! added by RW
 
-! --------------------------------------------------------
-!     The usual Tests
-!     --------------
-      IF (nlayer.NE.nlayermx) THEN
-         PRINT*,'STOP in inifis'
-         PRINT*,'Probleme de dimensions :'
-         PRINT*,'nlayer     = ',nlayer
-         PRINT*,'nlayermx   = ',nlayermx
-         STOP
-      ENDIF
 
       ! read in 'ecritphy' (frequency of calls to physics, in dynamical steps)
Index: trunk/LMDZ.GENERIC/libf/phystd/iniorbit.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniorbit.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniorbit.F	(revision 1308)
@@ -1,4 +1,7 @@
       SUBROUTINE iniorbit
      $     (papoastr,pperiastr,pyear_day,pperi_day,pobliq)
+      
+      USE planete_mod, only: apoastr, periastr, year_day, obliquit,
+     &                       peri_day, e_elips, p_elips, timeperi
       IMPLICIT NONE
 
@@ -19,5 +22,5 @@
 c   ----------
 c   - Doit etre appele avant d'utiliser orbite.
-c   - initialise une partie du common planete.h
+c   - initialise une partie du common planete_mod
 c
 c   Arguments:
@@ -35,5 +38,5 @@
 c   -------------
 
-#include "planete.h"
+!#include "planete.h"
 #include "comcstfi.h"
 
Index: trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90	(revision 1308)
@@ -16,6 +16,9 @@
                        rlatd ! latitudes
 use infotrac, only : nqtot ! number of advected tracers
+use planete_mod, only: ini_planete_mod
 
 implicit none
+include "dimensions.h"
+include "comvert.h"
 
 real,intent(in) :: prad ! radius of the planet (m)
@@ -67,4 +70,7 @@
 rlatd(1:klon_omp)=plat(offset+klon_omp_begin:offset+klon_omp_end)
 
+! copy over preff , ap() and bp() 
+call ini_planete_mod(nlayer,preff,ap,bp)
+
 ! copy some fundamental parameters to physics 
 ! and do some initializations 
Index: trunk/LMDZ.GENERIC/libf/phystd/initracer.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1308)
@@ -24,5 +24,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 1308)
@@ -34,5 +34,5 @@
 #include "netcdf.inc"
 #include "serre.h"
-#include"dimphys.h"
+!#include"dimphys.h"
 
 c   Arguments:
Index: trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 1308)
@@ -34,5 +34,5 @@
 #include "netcdf.inc"
 #include "serre.h"
-#include"dimphys.h"
+!#include"dimphys.h"
 
 c   Arguments:
Index: trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 1308)
@@ -7,4 +7,5 @@
   use ioipsl_getincom, only: getin
   use comsaison_h, only: mu0, fract, dist_star
+  use planete_mod
 !  use control_mod
 
@@ -30,8 +31,8 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 #include "comcstfi.h"
-#include "planete.h"
+!#include "planete.h"
 !#include "control.h"
 
@@ -42,8 +43,8 @@
   integer nlayer,nlevel,nq
   integer ilay,ilev,iq,iw,iter
-  real play(nlayermx)     ! Pressure at the middle of the layers [Pa]
-  real zlay(nlayermx)     ! Altitude at middle of the layers [km]
-  real plev(nlayermx+1)   ! Intermediate pressure levels [Pa]
-  real temp(nlayermx)     ! temperature at the middle of the layers [K]
+  real play(llm)     ! Pressure at the middle of the layers [Pa]
+  real zlay(llm)     ! Altitude at middle of the layers [km]
+  real plev(llm+1)   ! Intermediate pressure levels [Pa]
+  real temp(llm)     ! temperature at the middle of the layers [K]
   real,allocatable :: q(:,:)   ! tracer mixing ratio [kg/kg]
   real,allocatable :: vmr(:,:) ! tracer mixing ratio [mol/mol]
@@ -53,8 +54,8 @@
   real emis, albedo
 
-  real muvar(nlayermx+1)
-
-  real dtsw(nlayermx) ! heating rate (K/s) due to SW
-  real dtlw(nlayermx) ! heating rate (K/s) due to LW
+  real muvar(llm+1)
+
+  real dtsw(llm) ! heating rate (K/s) due to SW
+  real dtlw(llm) ! heating rate (K/s) due to LW
   real fluxsurf_lw   ! incident LW flux to surf (W/m2)
   real fluxtop_lw    ! outgoing LW flux to space (W/m2)
@@ -64,12 +65,12 @@
 
   ! not used
-  real reffrad(nlayermx,naerkind)
-  real nueffrad(nlayermx,naerkind)
-  real cloudfrac(nlayermx)
+  real reffrad(llm,naerkind)
+  real nueffrad(llm,naerkind)
+  real cloudfrac(llm)
   real totcloudfrac
   real tau_col
 
   real dTstrat
-  real aerosol(nlayermx,naerkind) ! aerosol tau (kg/kg)
+  real aerosol(llm,naerkind) ! aerosol tau (kg/kg)
   real OLR_nu(1,L_NSPECTI)
   real OSR_nu(1,L_NSPECTV)
@@ -93,5 +94,5 @@
 
 
-  nlayer=nlayermx
+  nlayer=llm
   nlevel=nlayer+1
 
@@ -225,6 +226,6 @@
         ! allocate arrays which depend on number of tracers
         allocate(nametrac(nq))
-        allocate(q(nlayermx,nq))
-        allocate(vmr(nlayermx,nq))
+        allocate(q(nlayer,nq))
+        allocate(vmr(nlayer,nq))
         allocate(qsurf(nq))
 
@@ -268,5 +269,5 @@
 
      !    Create vertical profiles
-     call kcmprof_fn(psurf,qsurf(1),tsurf,    &
+     call kcmprof_fn(nlayer,psurf,qsurf(1),tsurf,    &
           tstrat,play,plev,zlay,temp,q(:,1),muvar(1))
 
@@ -316,5 +317,5 @@
   ! Calculate total atmospheric energy
   Eatmtot=0.0
-  !  call calcenergy_kcm(tsurf,temp,play,plev,qsurf,&
+  !  call calcenergy_kcm(nlayer,tsurf,temp,play,plev,qsurf,&
   !     q(:,1),muvar,Eatmtot)
 
Index: trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 1308)
@@ -1,3 +1,3 @@
-subroutine kcmprof_fn(psurf_rcm,qsurf_rcm,Tsurf_rcm,Tstra_rcm,P_rcm,Pl_rcm,z_rcm,T_rcm,q_rcm,m_rcm)
+subroutine kcmprof_fn(nlayer,psurf_rcm,qsurf_rcm,Tsurf_rcm,Tstra_rcm,P_rcm,Pl_rcm,z_rcm,T_rcm,q_rcm,m_rcm)
 
 use params_h
@@ -12,6 +12,6 @@
 !     ----------------------------------------------------------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -21,13 +21,14 @@
 
   ! rcm inputs
+  integer nlayer
   real Tsurf_rcm,Tstra_rcm
 
   ! rcm outputs
   real psurf_rcm,qsurf_rcm
-  real P_rcm(1:nlayermx)
-  real Pl_rcm(1:nlayermx+1)
-  real z_rcm(1:nlayermx)
-  real T_rcm(1:nlayermx),q_rcm(1:nlayermx)
-  real m_rcm(1:nlayermx+1)
+  real P_rcm(1:nlayer)
+  real Pl_rcm(1:nlayer+1)
+  real z_rcm(1:nlayer)
+  real T_rcm(1:nlayer),q_rcm(1:nlayer)
+  real m_rcm(1:nlayer+1)
 
   ! rcm for interpolation (should really use log coords?)
@@ -161,13 +162,13 @@
 
   ! define fine pressure grid
-  dlogp_rcm = -(log(psurf_rcm)-log(ptop))/nlayermx
+  dlogp_rcm = -(log(psurf_rcm)-log(ptop))/nlayer
 
   P_rcm(1)  = psurf_rcm*exp(dlogp_rcm)
-  do ilay_rcm=1,nlayermx-1
+  do ilay_rcm=1,nlayer-1
      P_rcm(ilay_rcm+1) = P_rcm(ilay_rcm)*exp(dlogp_rcm)
   enddo
 
   Pl_rcm(1) = psurf_rcm
-  do ilev_rcm=2,nlayermx
+  do ilev_rcm=2,nlayer
      ! log-linear interpolation
      Pl_rcm(ilev_rcm) = exp( log( P_rcm(ilev_rcm)*P_rcm(ilev_rcm-1) )/2 )
@@ -318,5 +319,5 @@
   do ilay=2,nlay
 
-     if(ilay_rcm.le.nlayermx)then
+     if(ilay_rcm.le.nlayer)then
      ! interpolate rcm variables
 
@@ -349,10 +350,10 @@
 
   ifinal_rcm=ilay_rcm-1
-  if(ifinal_rcm.lt.nlayermx)then
+  if(ifinal_rcm.lt.nlayer)then
      if(verbose)then
         print*,'Interpolation in kcmprof stopped at layer',ilay_rcm,'!'
      endif
 
-     do ilay_rcm=ifinal_rcm+1,nlayermx
+     do ilay_rcm=ifinal_rcm+1,nlayer
 
         z_rcm(ilay_rcm) = z_rcm(ilay_rcm-1)
@@ -364,5 +365,5 @@
   endif
 
-  do ilay=2,nlayermx
+  do ilay=2,nlayer
      if(T_rcm(ilay).lt.Ttop)then
         T_rcm(ilay)=Ttop
@@ -373,5 +374,5 @@
   if(co2cond)then
      print*,'CO2 condensation haircut - assumes CO2-dominated atmosphere!'
-     do ilay=2,nlayermx
+     do ilay=2,nlayer
         if(P_rcm(ilay).lt.518000.)then
            TCO2cond = (-3167.8)/(log(.01*P_rcm(ilay))-23.23) ! Fanale's formula
Index: trunk/LMDZ.GENERIC/libf/phystd/largescale.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/largescale.F90	(revision 1308)
@@ -1,4 +1,4 @@
-      subroutine largescale(ngrid,nq,ptimestep, pplev, pplay, pt, pq,   &
-                        pdt, pdq, pdtlsc, pdqvaplsc, pdqliqlsc, rneb)
+      subroutine largescale(ngrid,nlayer,nq,ptimestep, pplev, pplay,    &
+                    pt, pq, pdt, pdq, pdtlsc, pdqvaplsc, pdqliqlsc, rneb)
 
 
@@ -23,24 +23,24 @@
 !==================================================================
 
-#include "dimensions.h" 
-#include "dimphys.h"
+!#include "dimensions.h" 
+!#include "dimphys.h"
 #include "comcstfi.h"
 
 #include "callkeys.h"
 
-      INTEGER ngrid,nq
+      INTEGER ngrid,nlayer,nq
 
 !     Arguments
       REAL ptimestep                 ! intervalle du temps (s)
-      REAL pplev(ngrid,nlayermx+1) ! pression a inter-couche
-      REAL pplay(ngrid,nlayermx)   ! pression au milieu de couche
-      REAL pt(ngrid,nlayermx)      ! temperature (K)
-      REAL pq(ngrid,nlayermx,nq) ! tracer mixing ratio (kg/kg)
-      REAL pdt(ngrid,nlayermx)     ! physical temperature tenedency (K/s)
-      REAL pdq(ngrid,nlayermx,nq)! physical tracer tenedency (K/s)
-      REAL pdtlsc(ngrid,nlayermx)  ! incrementation de la temperature (K)
-      REAL pdqvaplsc(ngrid,nlayermx) ! incrementation de la vapeur d'eau
-      REAL pdqliqlsc(ngrid,nlayermx) ! incrementation de l'eau liquide
-      REAL rneb(ngrid,nlayermx)    ! fraction nuageuse
+      REAL pplev(ngrid,nlayer+1) ! pression a inter-couche
+      REAL pplay(ngrid,nlayer)   ! pression au milieu de couche
+      REAL pt(ngrid,nlayer)      ! temperature (K)
+      REAL pq(ngrid,nlayer,nq) ! tracer mixing ratio (kg/kg)
+      REAL pdt(ngrid,nlayer)     ! physical temperature tenedency (K/s)
+      REAL pdq(ngrid,nlayer,nq)! physical tracer tenedency (K/s)
+      REAL pdtlsc(ngrid,nlayer)  ! incrementation de la temperature (K)
+      REAL pdqvaplsc(ngrid,nlayer) ! incrementation de la vapeur d'eau
+      REAL pdqliqlsc(ngrid,nlayer) ! incrementation de l'eau liquide
+      REAL rneb(ngrid,nlayer)    ! fraction nuageuse
 
 
@@ -63,7 +63,7 @@
       
 ! evaporation calculations
-      REAL dqevap(ngrid,nlayermx),dtevap(ngrid,nlayermx)     
-      REAL qevap(ngrid,nlayermx,nq)
-      REAL tevap(ngrid,nlayermx)
+      REAL dqevap(ngrid,nlayer),dtevap(ngrid,nlayer)     
+      REAL qevap(ngrid,nlayer,nq)
+      REAL tevap(ngrid,nlayer)
 
       DOUBLE PRECISION zx_q(ngrid)
@@ -83,13 +83,13 @@
 !     GCM -----> subroutine variables, initialisation of outputs
 
-      pdtlsc(1:ngrid,1:nlayermx)  = 0.0
-      pdqvaplsc(1:ngrid,1:nlayermx)  = 0.0
-      pdqliqlsc(1:ngrid,1:nlayermx) = 0.0
-      rneb(1:ngrid,1:nlayermx) = 0.0
+      pdtlsc(1:ngrid,1:nlayer)  = 0.0
+      pdqvaplsc(1:ngrid,1:nlayer)  = 0.0
+      pdqliqlsc(1:ngrid,1:nlayer) = 0.0
+      rneb(1:ngrid,1:nlayer) = 0.0
       Lcp=RLVTT/RCPD
 
 
       ! Evaporate cloud water/ice
-      call evap(ngrid,nq,ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
+      call evap(ngrid,nlayer,nq,ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
       ! note: we use qevap but not tevap in largescale/moistadj
             ! otherwise is a big mess
@@ -97,5 +97,5 @@
 
 !  Boucle verticale (du haut vers le bas)
-   DO k = nlayermx, 1, -1
+   DO k = nlayer, 1, -1
 
       zt(1:ngrid)=pt(1:ngrid,k)+(pdt(1:ngrid,k)+dtevap(1:ngrid,k))*ptimestep
@@ -171,7 +171,6 @@
          pdtlsc(1:ngrid,k)  = pdqliqlsc(1:ngrid,k)*real(Lcp)
 
-   Enddo ! k= nlayermx, 1, -1
+   Enddo ! k= nlayer, 1, -1
  
 
-      return
       end
Index: trunk/LMDZ.GENERIC/libf/phystd/lect_start_archive.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/lect_start_archive.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/lect_start_archive.F	(revision 1308)
@@ -1,3 +1,4 @@
-      SUBROUTINE lect_start_archive(date,tsurf,tsoil,emis,q2,
+      SUBROUTINE lect_start_archive(ngrid,nlayer,
+     &     date,tsurf,tsoil,emis,q2,
      &     t,ucov,vcov,ps,h,phisold_newgrid,
      &     q,qsurf,surfith,nid,
@@ -30,5 +31,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 !#include "planete.h"
 #include "paramet.h"
@@ -47,4 +48,6 @@
 c=======================================================================
 
+      INTEGER,INTENT(IN) :: ngrid, nlayer
+
 c Old variables dimensions (from file)
 c------------------------------------
@@ -99,13 +102,13 @@
 c variable physique
 c------------------
-      REAL tsurf(ngridmx) ! surface temperature
-      REAL tsoil(ngridmx,nsoilmx) ! soil temperature
-      REAL co2ice(ngridmx) ! CO2 ice layer
-      REAL emis(ngridmx)
-      REAL q2(ngridmx,nlayermx+1),qsurf(ngridmx,nqtot)
-      REAL tslab(ngridmx,noceanmx)
-      REAL rnat(ngridmx),pctsrf_sic(ngridmx)
-      REAL tsea_ice(ngridmx),sea_ice(ngridmx)
-c     REAL phisfi(ngridmx)
+      REAL tsurf(ngrid) ! surface temperature
+      REAL tsoil(ngrid,nsoilmx) ! soil temperature
+      REAL co2ice(ngrid) ! CO2 ice layer
+      REAL emis(ngrid)
+      REAL q2(ngrid,llm+1),qsurf(ngrid,nqtot)
+      REAL tslab(ngrid,noceanmx)
+      REAL rnat(ngrid),pctsrf_sic(ngrid)
+      REAL tsea_ice(ngrid),sea_ice(ngrid)
+c     REAL phisfi(ngrid)
 
       INTEGER i,j,l
@@ -322,5 +325,5 @@
       allocate(varp1 (imold+1,jmold+1,llm+1))
 
-      write(*,*) 'q2',ngridmx,nlayermx+1
+      write(*,*) 'q2',ngrid,llm+1
       write(*,*) 'q2S',iip1,jjp1,llm+1
       write(*,*) 'q2old',imold+1,jmold+1,lmold+1
@@ -1052,5 +1055,5 @@
       call interp_horiz (tsurfold,tsurfs,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,tsurfs,tsurf)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,tsurfs,tsurf)
 c     write(44,*) 'tsurf', tsurf
 
@@ -1059,5 +1062,5 @@
 !     &                  imold,jmold,iim,jjm,nsoilmx,
 !     &                   rlonuold,rlatvold,rlonu,rlatv)
-!      call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngridmx,tsoils,tsoil)
+!      call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngrid,tsoils,tsoil)
 c     write(45,*) 'tsoil',tsoil
 
@@ -1065,5 +1068,5 @@
       call interp_horiz (emisold,emiss,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,emiss,emis)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,emiss,emis)
 c     write(46,*) 'emis',emis
 
@@ -1201,5 +1204,5 @@
 
       ! Reshape inertiedatS to scalar grid as inertiedat
-      call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngridmx,
+      call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngrid,
      &                  inertiedatS,inertiedat)
       
@@ -1287,5 +1290,5 @@
 
       ! Reshape tsoilS to scalar grid as tsoil
-       call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngridmx,tsoilS,tsoil)
+       call gr_dyn_fi (nsoilmx,iim+1,jjm+1,ngrid,tsoilS,tsoil)
 
 c-----------------------------------------------------------------------
@@ -1294,21 +1297,21 @@
       call interp_horiz (tslabold,tslabs,imold,jmold,iim,jjm,noceanmx,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,tslabs,tslab)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,tslabs,tslab)
 
       call interp_horiz (rnatold,rnats,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,rnats,rnat)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,rnats,rnat)
 
       call interp_horiz (pctsrf_sicold,pctsrf_sics,imold,jmold,iim,
      &                   jjm,1,rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,pctsrf_sics,pctsrf_sic)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,pctsrf_sics,pctsrf_sic)
 
       call interp_horiz (tsea_iceold,tsea_ices,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,tsea_ices,tsea_ice)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,tsea_ices,tsea_ice)
 
       call interp_horiz (sea_iceold,sea_ices,imold,jmold,iim,jjm,1,
      &                   rlonuold,rlatvold,rlonu,rlatv)
-      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,sea_ices,sea_ice)
+      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,sea_ices,sea_ice)
 
 c-----------------------------------------------------------------------
@@ -1334,5 +1337,5 @@
      &                   rlonuold,rlatvold,rlonu,rlatv)
       write (*,*) 'lect_start_archive: q2s ', q2s (1,2,1)  ! INFO
-      call gr_dyn_fi (llm+1,iim+1,jjm+1,ngridmx,q2s,q2)
+      call gr_dyn_fi (llm+1,iim+1,jjm+1,ngrid,q2s,q2)
       write (*,*) 'lect_start_archive: q2 ', q2 (1,2)  ! INFO
 c     write(47,*) 'q2',q2
@@ -1384,5 +1387,5 @@
       enddo
 
-      call gr_dyn_fi (nqtot,iim+1,jjm+1,ngridmx,qsurfs,qsurf)
+      call gr_dyn_fi (nqtot,iim+1,jjm+1,ngrid,qsurfs,qsurf)
 
 c traceurs 3D
@@ -1435,5 +1438,5 @@
       enddo
       
-!      call gr_dyn_fi (1,iim+1,jjm+1,ngridmx,co2ices,co2ice)
+!      call gr_dyn_fi (1,iim+1,jjm+1,ngrid,co2ices,co2ice)
 ! no need to transfer "co2ice" any more; it is in qsurf(igcm_co2_ice)
 
Index: trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 1308)
@@ -9,4 +9,5 @@
        USE comgeomfi_h
        USE tracer_h
+       USE planete_mod, only: bp
 
        IMPLICIT NONE
@@ -50,9 +51,9 @@
 !    ------------------
 !
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
-#include "comvert.h"
-#include "paramet.h"
+!#include "comvert.h"
+!#include "paramet.h"
 #include "callkeys.h"
 
@@ -84,17 +85,18 @@
 
 !    vertical reorganization of sigma levels
-      REAL zzu(nlayermx),zzv(nlayermx)
-      REAL zzq(nlayermx,nq),zzt(nlayermx)
+      REAL zzu(nlayer),zzv(nlayer)
+      REAL zzq(nlayer,nq),zzt(nlayer)
 !    Dummy variables      
       INTEGER n,l,ig,iq
-      REAL zdtsig(ngrid,nlayermx)
-      REAL zmass(ngrid,nlayermx),zzmass(nlayermx),w(nlayermx+1)
-      REAL zdmass_sum(ngrid,nlayermx+1)
-      REAL zmflux(nlayermx+1)
-      REAL zq1(nlayermx)
+      REAL zdtsig(ngrid,nlayer)
+      REAL zmass(ngrid,nlayer),zzmass(nlayer),w(nlayer+1)
+      REAL zdmass_sum(ngrid,nlayer+1)
+      REAL zmflux(nlayer+1)
+      REAL zq1(nlayer)
       REAL ztsrf(ngrid)
-      REAL ztm(nlayermx+1) 
-      REAL zum(nlayermx+1) , zvm(nlayermx+1)
-      REAL zqm(nlayermx+1,nq),zqm1(nlayermx+1)
+      REAL ztm(nlayer+1) 
+      REAL zum(nlayer+1) , zvm(nlayer+1)
+      REAL zqm(nlayer+1,nq),zqm1(nlayer+1)
+      REAL sigma(nlayer+1)
 
 !   local saved variables
@@ -127,6 +129,6 @@
 
       DO ig=1,ngrid
-         zdmass_sum(ig,nlayermx+1)=0.
-         DO l = nlayermx, 1, -1
+         zdmass_sum(ig,nlayer+1)=0.
+         DO l = nlayer, 1, -1
            zmass(ig,l) = (pplev(ig,l)-pplev(ig,l+1))/glat(ig)
 	   zdmass_sum(ig,l)= zdmass_sum(ig,l+1)+pdmassmr(ig,l)
@@ -181,26 +183,32 @@
 !  Correction to account for redistribution between sigma or hybrid 
 !  layers when changing surface pressure
-!  zzx quantities have dimension (nlayermx) to speed up calculation
+!  zzx quantities have dimension (nlayer) to speed up calculation
 ! *************************************************************
 
       DO ig=1,ngrid
-         zzt(1:nlayermx)  = pt(ig,1:nlayermx) + pdt(ig,1:nlayermx) * ptimestep
-         zzu(1:nlayermx)  = pu(ig,1:nlayermx) + pdu(ig,1:nlayermx) * ptimestep
-         zzv(1:nlayermx)  = pv(ig,1:nlayermx) + pdv(ig,1:nlayermx) * ptimestep
-         zzq(1:nlayermx,1:nq)=pq(ig,1:nlayermx,1:nq)+pdq(ig,1:nlayermx,1:nq)*ptimestep ! must add the water that has fallen???
+         zzt(1:nlayer)  = pt(ig,1:nlayer) + pdt(ig,1:nlayer) * ptimestep
+         zzu(1:nlayer)  = pu(ig,1:nlayer) + pdu(ig,1:nlayer) * ptimestep
+         zzv(1:nlayer)  = pv(ig,1:nlayer) + pdv(ig,1:nlayer) * ptimestep
+         zzq(1:nlayer,1:nq)=pq(ig,1:nlayer,1:nq)+pdq(ig,1:nlayer,1:nq)*ptimestep ! must add the water that has fallen???
 
 !  Mass fluxes of air through the sigma levels (kg.m-2.s-1)  (>0 when up)
 !  """"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
-
          zmflux(1) = zmassboil(ig)
+         sigma(1)=1
          DO l=1,nlayer
+           ! Ehouarn: shouldn't we rather compute sigma levels than use bp()?
+!           sigma(l+1)=pplev(ig,l+1)/pplev(ig,1)
+!           zmflux(l+1) = zmflux(l) + pdmassmr(ig,l) - &
+!                        (sigma(l)-sigma(l+1))*(zdmass_sum(ig,1)+zmflux(1))
+!            if (abs(zmflux(l+1)).lt.1E-13.OR.sigma(l+1).eq.0.) zmflux(l+1)=0.
+           ! Ehouarn: but for now leave things as before
             zmflux(l+1) = zmflux(l) + pdmassmr(ig,l) - (bp(l)-bp(l+1))*(zdmass_sum(ig,1)+zmflux(1))
 ! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld  
-            if (abs(zmflux(l+1)).lt.1E-13.OR.bp(l+1).eq.0.) zmflux(l+1)=0.
+            if (abs(zmflux(l+1)).lt.1E-13.OR.sigma(l+1).eq.0.) zmflux(l+1)=0.
          END DO
 
 ! Mass of each layer
 ! ------------------ 
-         zzmass(1:nlayermx)=zmass(ig,1:nlayermx)*(1.+pdpsrfmr(ig)*ptimestep/pplev(ig,1))
+         zzmass(1:nlayer)=zmass(ig,1:nlayer)*(1.+pdpsrfmr(ig)*ptimestep/pplev(ig,1))
 
 
@@ -219,10 +227,10 @@
 	 
 !        Van Leer scheme:
-         w(1:nlayermx+1)=-zmflux(1:nlayermx+1)*ptimestep
+         w(1:nlayer+1)=-zmflux(1:nlayer+1)*ptimestep
          call vl1d(zzt,2.,zzmass,w,ztm) 
          call vl1d(zzu ,2.,zzmass,w,zum) 
          call vl1d(zzv ,2.,zzmass,w,zvm) 
          do iq=1,nq
-           zq1(1:nlayermx)=zzq(1:nlayermx,iq)
+           zq1(1:nlayer)=zzq(1:nlayer,iq)
            zqm1(1)=zqm(1,iq)
 !		print*,iq
Index: trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 1308)
@@ -1,6 +1,6 @@
-subroutine moistadj(ngrid, nq, pt, pq, pdq, pplev, pplay, pdtmana, pdqmana, ptimestep, rneb)
+subroutine moistadj(ngrid, nlayer, nq, pt, pq, pdq, pplev, pplay, pdtmana, pdqmana, ptimestep, rneb)
 
   use watercommon_h, only: T_h2O_ice_liq, RLVTT, RCPD, RCPV, Psat_water, Lcpdqsat_water
-  USE tracer_h
+  USE tracer_h, only: igcm_h2o_vap, igcm_h2o_ice
 
   implicit none
@@ -20,28 +20,27 @@
 !=====================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 
-      INTEGER ngrid, nq
-
-      REAL pt(ngrid,nlayermx)            ! temperature (K)
-      REAL pq(ngrid,nlayermx,nq)       ! tracer (kg/kg)
-      REAL pdq(ngrid,nlayermx,nq)
-
-      REAL pdqmana(ngrid,nlayermx,nq)  ! tendency of tracers (kg/kg.s-1)
-      REAL pdtmana(ngrid,nlayermx)       ! temperature increment
+      INTEGER,INTENT(IN) :: ngrid, nlayer, nq
+
+      REAL,INTENT(IN) :: pt(ngrid,nlayer) ! temperature (K)
+      REAL,INTENT(IN) :: pq(ngrid,nlayer,nq) ! tracer (kg/kg)
+      REAL,INTENT(IN) :: pdq(ngrid,nlayer,nq)
+      REAL,INTENT(IN) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
+      REAL,INTENT(IN) :: pplay(ngrid,nlayer)   ! mid-layer pressure (Pa)
+      REAL,INTENT(IN) :: ptimestep ! physics timestep (s)
+      REAL,INTENT(OUT) :: pdqmana(ngrid,nlayer,nq)  ! tracer tendencies (kg/kg.s-1)
+      REAL,INTENT(OUT) :: pdtmana(ngrid,nlayer) ! temperature increment(K/s)
+      REAL,INTENT(OUT) :: rneb(ngrid,nlayer) ! cloud fraction 
 
 !     local variables
-      REAL zt(ngrid,nlayermx)      ! temperature (K)
-      REAL zq(ngrid,nlayermx)      ! humidite specifique (kg/kg)
-      REAL pplev(ngrid,nlayermx+1) ! pression a inter-couche (Pa)
-      REAL pplay(ngrid,nlayermx)   ! pression au milieu de couche (Pa)
-
-      REAL d_t(ngrid,nlayermx)     ! temperature increment
-      REAL d_q(ngrid,nlayermx)     ! incrementation pour vapeur d'eau
-      REAL d_ql(ngrid,nlayermx)    ! incrementation pour l'eau liquide
-      REAL rneb(ngrid,nlayermx) ! cloud fraction 
-      REAL ptimestep
+      REAL zt(ngrid,nlayer)      ! temperature (K)
+      REAL zq(ngrid,nlayer)      ! humidite specifique (kg/kg)
+
+      REAL d_t(ngrid,nlayer)     ! temperature increment
+      REAL d_q(ngrid,nlayer)     ! incrementation pour vapeur d'eau
+      REAL d_ql(ngrid,nlayer)    ! incrementation pour l'eau liquide
 
 !      REAL t_coup
@@ -55,12 +54,12 @@
       INTEGER k1, k1p, k2, k2p
       LOGICAL itest(ngrid)
-      REAL delta_q(ngrid, nlayermx)
-      DOUBLE PRECISION :: cp_new_t(nlayermx), v_cptt(ngrid,nlayermx)
-      REAL cp_delta_t(nlayermx)
-      DOUBLE PRECISION :: v_cptj(nlayermx), v_cptjk1, v_ssig
+      REAL delta_q(ngrid, nlayer)
+      DOUBLE PRECISION :: cp_new_t(nlayer), v_cptt(ngrid,nlayer)
+      REAL cp_delta_t(nlayer)
+      DOUBLE PRECISION :: v_cptj(nlayer), v_cptjk1, v_ssig
       REAL v_p, v_t, v_zqs,v_cptt2,v_pratio,v_dlnpsat
-      REAL zqs(ngrid,nlayermx), zdqs(ngrid,nlayermx),zpsat(ngrid,nlayermx),zdlnpsat(ngrid,nlayermx)
+      REAL zqs(ngrid,nlayer), zdqs(ngrid,nlayer),zpsat(ngrid,nlayer),zdlnpsat(ngrid,nlayer)
       REAL zq1(ngrid), zq2(ngrid)
-      DOUBLE PRECISION :: gamcpdz(ngrid,2:nlayermx)
+      DOUBLE PRECISION :: gamcpdz(ngrid,2:nlayer)
       DOUBLE PRECISION :: zdp, zdpm
 
@@ -68,5 +67,5 @@
       REAL zflo ! flotabilite
 
-      DOUBLE PRECISION :: local_q(ngrid,nlayermx),local_t(ngrid,nlayermx)
+      DOUBLE PRECISION :: local_q(ngrid,nlayer),local_t(ngrid,nlayer)
 
       REAL zdelta, zcor, zcvm5
@@ -79,8 +78,5 @@
       INTEGER,SAVE :: i_ice=0  ! water ice
 
-      LOGICAL firstcall
-      SAVE firstcall
-
-      DATA firstcall /.TRUE./
+      LOGICAL,SAVE :: firstcall=.TRUE.
 
       IF (firstcall) THEN
@@ -96,9 +92,9 @@
 
 !     GCM -----> subroutine variables
-      zq(1:ngrid,1:nlayermx)    = pq(1:ngrid,1:nlayermx,i_h2o)+ pdq(1:ngrid,1:nlayermx,i_h2o)*ptimestep
-      zt(1:ngrid,1:nlayermx)    = pt(1:ngrid,1:nlayermx)
-      pdqmana(1:ngrid,1:nlayermx,1:nq)=0.0
-
-      DO k = 1, nlayermx
+      zq(1:ngrid,1:nlayer)    = pq(1:ngrid,1:nlayer,i_h2o)+ pdq(1:ngrid,1:nlayer,i_h2o)*ptimestep
+      zt(1:ngrid,1:nlayer)    = pt(1:ngrid,1:nlayer)
+      pdqmana(1:ngrid,1:nlayer,1:nq)=0.0
+
+      DO k = 1, nlayer
        DO i = 1, ngrid
          if(zq(i,k).lt.0.)then
@@ -108,13 +104,13 @@
       ENDDO
       
-      local_q(1:ngrid,1:nlayermx) = zq(1:ngrid,1:nlayermx)
-      local_t(1:ngrid,1:nlayermx) = zt(1:ngrid,1:nlayermx)
-      rneb(1:ngrid,1:nlayermx) = 0.0
-      d_ql(1:ngrid,1:nlayermx) = 0.0
-      d_t(1:ngrid,1:nlayermx)  = 0.0
-      d_q(1:ngrid,1:nlayermx)  = 0.0
+      local_q(1:ngrid,1:nlayer) = zq(1:ngrid,1:nlayer)
+      local_t(1:ngrid,1:nlayer) = zt(1:ngrid,1:nlayer)
+      rneb(1:ngrid,1:nlayer) = 0.0
+      d_ql(1:ngrid,1:nlayer) = 0.0
+      d_t(1:ngrid,1:nlayer)  = 0.0
+      d_q(1:ngrid,1:nlayer)  = 0.0
 
 !     Calculate v_cptt
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
          DO i = 1, ngrid
             v_cptt(i,k) = RCPD * local_t(i,k)
@@ -128,5 +124,5 @@
 
 !     Calculate Gamma * Cp * dz: (gamma is the critical gradient)
-      DO k = 2, nlayermx
+      DO k = 2, nlayer
          DO i = 1, ngrid
             zdp = pplev(i,k)-pplev(i,k+1)
@@ -159,5 +155,5 @@
   810 CONTINUE ! look for k1, the base of the column
       k2 = k2 + 1
-      IF (k2 .GT. nlayermx) GOTO 9999
+      IF (k2 .GT. nlayer) GOTO 9999
       zflo = v_cptt(i,k2-1) - v_cptt(i,k2) - gamcpdz(i,k2)
       zsat=(local_q(i,k2-1)-zqs(i,k2-1))*(pplev(i,k2-1)-pplev(i,k2))   &
@@ -169,5 +165,5 @@
 
   820 CONTINUE !! look for k2, the top of the column
-      IF (k2 .EQ. nlayermx) GOTO 821
+      IF (k2 .EQ. nlayer) GOTO 821
       k2p = k2 + 1
       zsat=zsat+(pplev(i,k2p)-pplev(i,k2p+1))*(local_q(i,k2p)-zqs(i,k2p))
@@ -227,5 +223,5 @@
 !      ENDDO
 
-      DO k = 2, nlayermx
+      DO k = 2, nlayer
          zdpm = pplev(i,k-1) - pplev(i,k)
          zdp = pplev(i,k) - pplev(i,k+1)
@@ -272,5 +268,5 @@
 ! a l'endroit ou la vapeur d'eau est diminuee par l'ajustement):
 
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
          IF (itest(i)) THEN
@@ -291,5 +287,5 @@
          ENDIF
       ENDDO
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
          IF (itest(i)) THEN
@@ -300,5 +296,5 @@
       ENDDO
       ENDDO
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
          IF (itest(i)) THEN
@@ -308,5 +304,5 @@
       ENDDO
 
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
           local_q(i, k) = MAX(local_q(i, k), seuil_vap)
@@ -314,5 +310,5 @@
       ENDDO
 
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
          d_t(i,k) = local_t(i,k) - zt(i,k)
@@ -322,5 +318,5 @@
 
 !     now subroutine -----> GCM variables
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
          DO i = 1, ngrid
             
@@ -333,4 +329,3 @@
 
 
-      RETURN
    END
